	list p=12f629
	#include <p12f629.inc>
	radix dec
; Microcontroller model: PIC12F629
; Clock frequency: 4.0 MHz
;
	dp EQU 0x2D
	code EQU 0x2E
	guess EQU 0x30
	xcount EQU 0x32
	j EQU 0x34
	newcode EQU 0x35
	ucount EQU 0x37
; Begin
	R0L EQU 0x20
	R0H EQU 0x21
	R1L EQU 0x22
	R1H EQU 0x23
	R2L EQU 0x24
	R2H EQU 0x25
	R3L EQU 0x26
	R3H EQU 0x27
	R4L EQU 0x28
	R4H EQU 0x29
	R5L EQU 0x2A
	R5H EQU 0x2B
	ARRARG_0 EQU 0x2C
	ORG 0x0000
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0004
	ORG 0x0004
	RETFIE
; Begin of program
L0004:
; 39: INTCON.T0IE = 0  'disenable Timer0 interrupts
	BCF 0x0B,5
; 40: INTCON.GIE = 0  'disable all un-masked interrupts
	BCF 0x0B,7
; 41: OPTION_REG.T0CS = 0  'set Timer0 clock source to internal instruction cycle clock
	BSF STATUS,RP0
	BCF 0x01,5
; 42: OPTION_REG.7 = 0  '0=enable pull up resistors!  13L1
	BCF 0x01,7
	BCF STATUS,RP0
; 43: CMCON = %11111111  'All digital I/O (REQUIRED)
	MOVLW 0xFF
	MOVWF 0x19
; 44: TRISIO = %11001111  '0=output 1=input (REQUIRED)
	MOVLW 0xCF
	BSF STATUS,RP0
	MOVWF 0x05
	BCF STATUS,RP0
; 45: OSCCAL = %11111100
	MOVLW 0xFC
	BSF STATUS,RP0
	MOVWF 0x10
	BCF STATUS,RP0
; 46: WPU = %00000111  '13L1
	MOVLW 0x07
	BSF STATUS,RP0
	MOVWF 0x15
	BCF STATUS,RP0
; 48: main:
L0001:
	MOVLW 0x00
	BSF STATUS,RP0
	MOVWF EEADR
	BSF EECON1,RD
	NOP
	MOVF EEDATA,W
	BCF STATUS,RP0
	MOVWF 0x2E
	MOVLW 0x01
	BSF STATUS,RP0
	MOVWF EEADR
	BSF EECON1,RD
	NOP
	MOVF EEDATA,W
	BCF STATUS,RP0
	MOVWF 0x2F
	MOVF 0x2E,W
	SUBLW 0x00
	BTFSS STATUS,Z
	GOTO L0007
	GOTO L0006
L0007:
	MOVF 0x2F,W
	SUBLW 0x00
	BTFSS STATUS,Z
	GOTO L0005
L0006:
	MOVLW 0x03
	MOVWF 0x2E
	MOVLW 0x01
	MOVWF 0x2F
	MOVLW 0x00
	BSF STATUS,RP0
	MOVWF EEADR
	BCF STATUS,RP0
	MOVF 0x2E,W
	BSF STATUS,RP0
	MOVWF EEDATA
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
L0008:	BTFSC EECON1,WR
	GOTO L0008
	BCF EECON1,WREN
	BCF STATUS,RP0
	BCF PIR1,EEIF
	MOVLW 0x01
	BSF STATUS,RP0
	MOVWF EEADR
	BCF STATUS,RP0
	MOVF 0x2F,W
	BSF STATUS,RP0
	MOVWF EEDATA
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
L0009:	BTFSC EECON1,WR
	GOTO L0009
	BCF EECON1,WREN
	BCF STATUS,RP0
	BCF PIR1,EEIF
L0005:
	CLRF 0x2D
	BCF 0x33,2
	BTFSC 0x05,0
	BSF 0x33,0
	BTFSS 0x05,0
	BCF 0x33,0
	BTFSC 0x33,0
	BSF 0x33,1
	BTFSS 0x33,0
	BCF 0x33,1
	BSF 0x38,1
	CLRF 0x35
	CLRF 0x36
	CLRF 0x34
	BCF 0x33,5
	BTFSC 0x05,0
	BSF 0x33,3
	BTFSS 0x05,0
	BCF 0x33,3
	BTFSC 0x33,0
	BSF 0x33,4
	BTFSS 0x33,0
	BCF 0x33,4
	BSF 0x33,4
	BCF 0x33,6
	BCF 0x33,7
	BSF 0x05,4
L0002:
	BTFSC 0x05,0
	BSF 0x33,0
	BTFSS 0x05,0
	BCF 0x33,0
	BTFSC 0x33,0
	BSF 0x05,5
	BTFSS 0x33,0
	BCF 0x05,5
	BTFSC 0x33,0
	GOTO L0010
	BTFSS 0x33,1
	GOTO L0011
	BSF 0x33,2
	MOVF 0x2D,W
	ADDLW 0x30
	MOVWF FSR
	MOVF INDF,W
	ADDLW 0x01
	MOVWF R5L
	MOVF 0x2D,W
	ADDLW 0x30
	MOVWF FSR
	MOVF R5L,W
	MOVWF INDF
	MOVF 0x2D,W
	ADDLW 0x30
	MOVWF FSR
	MOVF INDF,W
	SUBLW 0x09
	BTFSC STATUS,C
	GOTO L0012
	MOVF 0x2D,W
	ADDLW 0x30
	MOVWF FSR
	CLRF INDF
L0012:
	CALL L0003
L0011:
	GOTO L0013
L0010:
	BTFSC 0x33,1
	GOTO L0014
	CLRF 0x32
	GOTO L0015
L0014:
	BTFSS 0x33,2
	GOTO L0016
	MOVF 0x32,W
	ADDLW 0x01
	MOVWF 0x32
L0016:
L0015:
L0013:
	BTFSC 0x33,0
	BSF 0x33,1
	BTFSS 0x33,0
	BCF 0x33,1
	MOVF 0x32,W
	SUBLW 0x4B
	BTFSS STATUS,Z
	GOTO L0017
	CALL L0003
	MOVF 0x2D,W
	ADDLW 0x01
	MOVWF 0x2D
	MOVF 0x2D,W
	SUBLW 0x02
	BTFSS STATUS,Z
	GOTO L0018
	MOVF 0x30,W
	SUBWF 0x2E,W
	BTFSS STATUS,Z
	GOTO L0019
	MOVF 0x31,W
	SUBWF 0x2F,W
	BTFSS STATUS,Z
	GOTO L0020
	BCF 0x33,6
	BCF 0x33,7
	CALL L0003
	MOVLW 0xC8
	MOVWF R0L
	CLRF R0H
	CALL W001
	CALL L0003
L0020:
L0019:
	BCF 0x33,2
	CLRF 0x32
	CLRF 0x2D
	CLRF 0x30
	CLRF 0x31
L0018:
L0017:
	BTFSC 0x33,7
	GOTO L0021
	BTFSC 0x05,1
	BSF 0x33,3
	BTFSS 0x05,1
	BCF 0x33,3
	BTFSC 0x33,3
	GOTO L0022
	BTFSS 0x33,4
	GOTO L0023
	BSF 0x33,5
	MOVF 0x34,W
	ADDLW 0x35
	MOVWF FSR
	MOVF INDF,W
	ADDLW 0x01
	MOVWF R5L
	MOVF 0x34,W
	ADDLW 0x35
	MOVWF FSR
	MOVF R5L,W
	MOVWF INDF
	MOVF 0x34,W
	ADDLW 0x35
	MOVWF FSR
	MOVF INDF,W
	SUBLW 0x09
	BTFSC STATUS,C
	GOTO L0024
	MOVF 0x34,W
	ADDLW 0x35
	MOVWF FSR
	CLRF INDF
L0024:
	CALL L0003
L0023:
	GOTO L0025
L0022:
	BTFSC 0x33,4
	GOTO L0026
	CLRF 0x37
	GOTO L0027
L0026:
	BTFSS 0x33,5
	GOTO L0028
	MOVF 0x37,W
	ADDLW 0x01
	MOVWF 0x37
L0028:
L0027:
L0025:
	BTFSC 0x33,3
	BSF 0x33,4
	BTFSS 0x33,3
	BCF 0x33,4
L0021:
	MOVF 0x37,W
	SUBLW 0x4B
	BTFSS STATUS,Z
	GOTO L0029
	CALL L0003
	MOVF 0x34,W
	ADDLW 0x01
	MOVWF 0x34
	MOVF 0x34,W
	SUBLW 0x02
	BTFSS STATUS,Z
	GOTO L0030
	MOVF 0x35,W
	SUBLW 0x00
	BTFSC STATUS,C
	GOTO L0031
	MOVF 0x36,W
	SUBLW 0x00
	BTFSC STATUS,C
	GOTO L0031
	MOVF 0x35,W
	MOVWF 0x2E
	MOVF 0x36,W
	MOVWF 0x2F
	MOVLW 0x00
	BSF STATUS,RP0
	MOVWF EEADR
	BCF STATUS,RP0
	MOVF 0x2E,W
	BSF STATUS,RP0
	MOVWF EEDATA
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
L0032:	BTFSC EECON1,WR
	GOTO L0032
	BCF EECON1,WREN
	BCF STATUS,RP0
	BCF PIR1,EEIF
	MOVLW 0x01
	BSF STATUS,RP0
	MOVWF EEADR
	BCF STATUS,RP0
	MOVF 0x2F,W
	BSF STATUS,RP0
	MOVWF EEDATA
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
L0033:	BTFSC EECON1,WR
	GOTO L0033
	BCF EECON1,WREN
	BCF STATUS,RP0
	BCF PIR1,EEIF
	BCF 0x05,5
	CALL L0003
	MOVLW 0x32
	MOVWF R0L
	CLRF R0H
	CALL W001
	CALL L0003
	BSF 0x05,5
	BCF 0x33,5
	CLRF 0x37
	CLRF 0x34
	CLRF 0x35
	CLRF 0x36
	GOTO L0034
L0031:
	CALL L0003
	CALL L0003
	CALL L0003
	BCF 0x33,5
	CLRF 0x37
	CLRF 0x34
	CLRF 0x35
	CLRF 0x36
L0034:
L0030:
L0029:
	BTFSC 0x05,2
	BSF 0x38,0
	BTFSS 0x05,2
	BCF 0x38,0
	BTFSC 0x38,0
	GOTO L0035
	BTFSS 0x38,1
	GOTO L0036
	BTFSS 0x33,6
	GOTO L0037
	BSF 0x33,7
	BCF 0x05,4
	GOTO L0038
L0037:
	BSF 0x33,6
L0038:
	BCF 0x33,2
	CLRF 0x32
	CLRF 0x2D
	CLRF 0x30
	CLRF 0x31
L0036:
L0035:
	BTFSC 0x38,0
	BSF 0x38,1
	BTFSS 0x38,0
	BCF 0x38,1
	MOVLW 0x64
	MOVWF R0L
	CLRF R0H
	CALL W001
	GOTO L0002
L0039:	GOTO L0039
L0003:
	BTFSC 0x33,7
	GOTO L0040
	BCF 0x05,4
	MOVLW 0x32
	MOVWF R0L
	CLRF R0H
	CALL W001
	BSF 0x05,4
	GOTO L0041
L0040:
	BSF 0x05,4
	MOVLW 0x32
	MOVWF R0L
	CLRF R0H
	CALL W001
	BCF 0x05,4
L0041:
	RETURN
L0042:	GOTO L0042
W001:	MOVF R0L,F
	BTFSC STATUS,Z
	GOTO W002
	CALL W003
	DECF R0L,F
	NOP
	NOP
	NOP
	NOP
	NOP
	GOTO W001
W002:	MOVF R0H,F
	BTFSC STATUS,Z
	RETURN
	CALL W003
	DECF R0H,F
	DECF R0L,F
	GOTO W001
W003:	MOVLW 0x0C
	MOVWF R2H
W004:
	DECFSZ R2H,F
	GOTO W004
	NOP
	NOP
	MOVLW 0x12
	MOVWF R1L
W005:
	DECFSZ R1L,F
	GOTO W006
	CALL W007
	CALL W007
	NOP
	NOP
	RETURN
W006:
	CALL W007
	GOTO W005
W007:	MOVLW 0x0D
	MOVWF R2L
W008:
	DECFSZ R2L,F
	GOTO W008
	NOP
	RETURN
; EEPROM data
	ORG 0x2100
	DW 0x03
	DW 0x01
	END
